﻿using System.Collections.Generic;
using Kreta.BusinessLogic.Helpers.Models;
using Kreta.Framework.Caching;

namespace Kreta.Job.Tasks.Cache
{
    public class OrarendValtozasCache : GenericCache<object>
    {
        private static readonly string orarendValtozasCache = $"{nameof(Kreta)}_{nameof(OrarendValtozasCache)}";

        public OrarendValtozasCache(CacheManager cacheManager) : base(cacheManager, nameof(OrarendValtozasCache)) { }

        protected string GetCacheKey(string intezmenyAzonosito)
        {
            return $"{orarendValtozasCache}_{intezmenyAzonosito}";
        }

        public List<OrarendValtozasModel> GetOrarendValtozasok(string intezmenyAzonosito)
        {
            return (List<OrarendValtozasModel>)Get(GetCacheKey(intezmenyAzonosito)) ?? new List<OrarendValtozasModel>();
        }

        public void AddOrUpdateOrarendValtozas(List<OrarendValtozasModel> value, string intezmenyAzonosito)
        {
            AddOrUpdate(GetCacheKey(intezmenyAzonosito), value, k => value);
        }

        public void RemoveOrarendValtozasok(string intezmenyAzonosito)
        {
            Remove(GetCacheKey(intezmenyAzonosito));
        }
    }
}
